"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function isValidMutation(Mutation) {
  try {
    if (!Mutation) {
      return false;
    }
    if ((0, _keys2.default)(Mutation.getFields()).length === 0) {
      return false;
    }
  } catch (e) {
    return false;
  }
  return true;
}

exports.default = async function MutationPlugin(builder) {
  builder.hook("GraphQLSchema", (schema, { newWithHooks, extend, graphql: { GraphQLObjectType } }) => {
    const Mutation = newWithHooks(GraphQLObjectType, {
      name: "Mutation",
      description: "The root mutation type which contains root level fields which mutate data."
    }, { isRootMutation: true }, true);
    if (isValidMutation(Mutation)) {
      return extend(schema, {
        mutation: Mutation
      });
    } else {
      return schema;
    }
  });
};
//# sourceMappingURL=MutationPlugin.js.map