"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function isValidSubscription(Subscription) {
  try {
    if (!Subscription) {
      return false;
    }
    if ((0, _keys2.default)(Subscription.getFields()).length === 0) {
      return false;
    }
  } catch (e) {
    return false;
  }
  return true;
}

exports.default = async function SubscriptionPlugin(builder) {
  builder.hook("GraphQLSchema", (schema, { newWithHooks, extend, graphql: { GraphQLObjectType } }) => {
    const Subscription = newWithHooks(GraphQLObjectType, {
      name: "Subscription",
      description: "The root subscription type which contains root level fields which mutate data."
    }, { isRootSubscription: true }, true);
    if (isValidSubscription(Subscription)) {
      return extend(schema, {
        subscription: Subscription
      });
    } else {
      return schema;
    }
  });
};
//# sourceMappingURL=SubscriptionPlugin.js.map